/***************************************************************\
*										*
*	Gfont.h, librairie mise au point par LIMachi		*
*	doit tre #include a la suite de "GrayscaleLib.c"		*
*										*
\***************************************************************/


/*******************************************************************************************************************************\
*																				*
*	GF_PrintXY( x, y, chaine, fond, couleur, couleur_de_fond);										*
*																				*
*	Cette 	fonction cherche a reproduire le PrintXY de base de "fxlib.h"									*
*	x et y sont les coordones du point de dpart de l'affichage de la chaine								*
*	fond=0 affiche la chaine directement dans les buffers sans ffacer au pralable la zone d'affichage de la chaine	*
*	fond=1 la fonction va afficher un fond uni dans les buffers avant d'y afficher la chaine					*
*	couleur determine la couleur (WHITE, LIGHT_GRAY, DARK_GRAY, REVERSE) des lettres					*
*	couleur_de_fond determine la couleur du fond (si fond=1)										*
*																				*
*	cette fonction retourne un char corespondant a y+la largeur de l'affichage de la chaine					*
*																				*
\*******************************************************************************************************************************/
char GF_PrintXY(char xs, char y, unsigned char *str,char back,GL_Color color,GL_Color bcolor)
{
	int l=0;
	char x,xt,i;
	unsigned char font[5]={0};

	x=xs;
	xt=xs;

	while(str[l])
	{

		xt+=4+(str[l]=='N' || str[l]=='z' || str[l]=='%')-(str[l]=='l' || str[l]=='.' || str[l]==',' || str[l]=='s' || str[l]=='!')+2*(str[l]=='M' || str[l]=='W' || str[l]=='m' || str[l]=='w');

		if(back)
			for(i=x;i<=xt;i++)
				GL_vertical_line(i,y,y+4,bcolor);

		switch(str[l])
		{
			case 'A':
				GL_vertical_line(x,y+1,y+4,color);
				GL_vertical_line(x+2,y+1,y+4,color);
				GL_pixel(x+1,y,color);
				GL_pixel(x+1,y+2,color);
			break;

			case 'B':
				GL_vertical_line(x,y,y+4,color);
				GL_pixel(x+1,y,color);
				GL_pixel(x+2,y+1,color);
				GL_pixel(x+1,y+2,color);
				GL_pixel(x+2,y+3,color);
				GL_pixel(x+1,y+4,color);
			break;

			case 'C':
				GL_vertical_line(x,y+1,y+3,color);
				GL_horizontal_line(y,x+1,x+2,color);
				GL_horizontal_line(y+4,x+1,x+2,color);
			break;

			case 'D':
				GL_vertical_line(x,y,y+4,color);
				GL_vertical_line(x+2,y+1,y+3,color);
				GL_pixel(x+1,y,color);
				GL_pixel(x+1,y+4,color);
			break;

			case 'E':
				GL_vertical_line(x,y,y+4,color);
				GL_horizontal_line(y,x+1,x+2,color);
				GL_horizontal_line(y+2,x+1,x+2,color);
				GL_horizontal_line(y+4,x+1,x+2,color);
			break;

			case 'F':
				GL_vertical_line(x,y,y+4,color);
				GL_horizontal_line(y,x+1,x+2,color);
				GL_horizontal_line(y+2,x+1,x+2,color);
			break;

			case 'G':
				GL_vertical_line(x,y+1,y+3,color);
				GL_horizontal_line(y,x+1,x+2,color);
				GL_horizontal_line(y+4,x+1,x+2,color);
				GL_vertical_line(x+2,y+2,y+3,color);
			break;

			case 'H':
				GL_vertical_line(x,y,y+4,color);
				GL_pixel(x+1,y+2,color);
				GL_vertical_line(x+2,y,y+4,color);
			break;

			case 'I':
				GL_horizontal_line(y,x,x+2,color);
				GL_vertical_line(x+1,y+1,y+3,color);
				GL_horizontal_line(y+4,x,x+2,color);
			break;

			case 'J':
				GL_pixel(x+1,y,color);
				GL_vertical_line(x+2,y,y+3,color);
				GL_pixel(x+1,y+4,color);
				GL_pixel(x,y+3,color);
			break;

			case 'K':
				GL_vertical_line(x,y,y+4,color);
				GL_vertical_line(x+2,y,y+1,color);
				GL_vertical_line(x+2,y+4,y+3,color);
				GL_pixel(x+1,y+2,color);
			break;

			case 'L':
				GL_horizontal_line(y+4,x+1,x+2,color);
				GL_vertical_line(x,y,y+4,color);
			break;

			case 'M':
				GL_vertical_line(x,y,y+4,color);
				GL_vertical_line(x+4,y,y+4,color);
				GL_pixel(x+1,y+1,color);
				GL_pixel(x+2,y+2,color);
				GL_pixel(x+3,y+1,color);
			break;

			case 'N':
				GL_vertical_line(x,y,y+4,color);
				GL_vertical_line(x+3,y,y+4,color);
				GL_pixel(x+1,y+1,color);
				GL_pixel(x+2,y+2,color);
			break;
			case 'O':
				GL_vertical_line(x,y+1,y+3,color);
				GL_vertical_line(x+2,y+1,y+3,color);
				GL_pixel(x+1,y,color);
				GL_pixel(x+1,y+4,color);
			break;

			case 'P':
				GL_vertical_line(x,y,y+4,color);
				GL_pixel(x+1,y,color);
				GL_pixel(x+2,y+1,color);
				GL_pixel(x+1,y+2,color);
			break;

			case 'Q':
				GL_vertical_line(x,y,y+3,color);
				GL_vertical_line(x+2,y,y+2,color);
				GL_pixel(x+1,y,color);
				GL_pixel(x+1,y+3,color);
				GL_pixel(x+2,y+4,color);
			break;

			case 'R':
				GL_vertical_line(x,y,y+4,color);
				GL_vertical_line(x+2,y+3,y+4,color);
				GL_pixel(x+1,y,color);
				GL_pixel(x+2,y+1,color);
				GL_pixel(x+1,y+2,color);
			break;

			case 'S':
				GL_horizontal_line(y,x+1,x+2,color);
				GL_horizontal_line(y+4,x,x+1,color);
				GL_pixel(x,y+1,color);
				GL_pixel(x+1,y+2,color);
				GL_pixel(x+2,y+3,color);
			break;

			case 'T':
				GL_horizontal_line(y,x,x+2,color);
				GL_vertical_line(x+1,y+1,y+4,color);
			break;

			case 'U':
				GL_vertical_line(x,y,y+4,color);
				GL_vertical_line(x+2,y,y+4,color);
				GL_pixel(x+1,y+4,color);
			break;

			case 'V':
				GL_vertical_line(x,y,y+3,color);
				GL_vertical_line(x+2,y,y+3,color);
				GL_pixel(x+1,y+4,color);
			break;

			case 'W':
				GL_vertical_line(x,y,y+3,color);
				GL_vertical_line(x+2,y,y+3,color);
				GL_vertical_line(x+4,y,y+3,color);
				GL_pixel(x+1,y+4,color);
				GL_pixel(x+3,y+4,color);
			break;

			case 'X':
				GL_vertical_line(x,y,y+1,color);
				GL_vertical_line(x+2,y,y+1,color);
				GL_pixel(x+1,y+2,color);
				GL_vertical_line(x,y+3,y+4,color);
				GL_vertical_line(x+2,y+3,y+4,color);
			break;

			case 'Y':
				GL_vertical_line(x,y,y+1,color);
				GL_vertical_line(x+2,y,y+1,color);
				GL_vertical_line(x+1,y+2,y+4,color);
			break;

			case 'Z':
				GL_horizontal_line(y,x,x+2,color);
				GL_horizontal_line(y+4,x,x+2,color);
				GL_pixel(x+2,y+1,color);
				GL_pixel(x+1,y+2,color);
				GL_pixel(x,y+3,color);
			break;

			case 'a':
				GL_vertical_line(x+2,y+1,y+4,color);
				GL_pixel(x+1,y,color);
				GL_pixel(x+1,y+2,color);
				GL_pixel(x+1,y+4,color);
				GL_pixel(x,y+3,color);
			break;

			case 'b':
				GL_vertical_line(x,y,y+4,color);
				GL_vertical_line(x+2,y+2,y+3,color);
				GL_pixel(x+1,y+1,color);
				GL_pixel(x+1,y+4,color);
			break;

			case 'c':
				GL_vertical_line(x,y+2,y+3,color);
				GL_horizontal_line(y+1,x+1,x+2,color);
				GL_horizontal_line(y+4,x+1,x+2,color);
			break;

			case 'd':
				GL_vertical_line(x+2,y,y+4,color);
				GL_vertical_line(x,y+2,y+3,color);
				GL_pixel(x+1,y+1,color);
				GL_pixel(x+1,y+4,color);
			break;

			case 'e':
				GL_vertical_line(x,y+1,y+3,color);
				GL_vertical_line(x+2,y+1,y+2,color);
				GL_horizontal_line(y+4,x+1,x+2,color);
				GL_pixel(x+1,y,color);
				GL_pixel(x+1,y+2,color);
			break;

			case 'f':
				GL_horizontal_line(y+2,x,x+2,color);
				GL_vertical_line(x+1,y+1,y+4,color);
				GL_pixel(x+2,y,color);
			break;

			case 'g':
				GL_horizontal_line(y+4,x,x+1,color);
				GL_vertical_line(x+2,y,y+3,color);
				GL_pixel(x+1,y,color);
				GL_pixel(x,y+1,color);
				GL_pixel(x+1,y+2,color);
			break;

			case 'h':
				GL_vertical_line(x,y,y+4,color);
				GL_pixel(x+1,y+2,color);
				GL_vertical_line(x+2,y+3,y+4,color);
			break;

			case 'i':
				GL_vertical_line(x+1,y+2,y+4,color);
				GL_pixel(x+1,y,color);
				GL_pixel(x,y+2,color);
				GL_pixel(x,y+4,color);
				GL_pixel(x+2,y+4,color);
			break;

			case 'j':
				GL_vertical_line(x+2,y+2,y+3,color);
				GL_pixel(x+2,y,color);
				GL_pixel(x,y+3,color);
				GL_pixel(x+1,y+4,color);
			break;

			case 'k':
				GL_vertical_line(x,y,y+4,color);
				GL_pixel(x+2,y+2,color);
				GL_pixel(x+1,y+3,color);
				GL_pixel(x+2,y+4,color);
			break;

			case 'l':
				GL_vertical_line(x+1,y,y+4,color);
				GL_pixel(x,y,color);
			break;

			case 'm':
				GL_vertical_line(x,y+1,y+4,color);
				GL_pixel(x+1,y+1,color);
				GL_vertical_line(x+2,y+2,y+4,color);
				GL_pixel(x+3,y+1,color);
				GL_vertical_line(x+4,y+2,y+4,color);
			break;

			case 'n':
				GL_vertical_line(x,y+1,y+4,color);
				GL_pixel(x+1,y+1,color);
				GL_vertical_line(x+2,y+2,y+4,color);
			break;

			case 'o':
				GL_vertical_line(x,y+2,y+3,color);
				GL_vertical_line(x+2,y+2,y+3,color);
				GL_pixel(x+1,y+1,color);
				GL_pixel(x+1,y+4,color);
			break;

			case 'p':
				GL_vertical_line(x,y+1,y+4,color);
				GL_pixel(x+1,y+1,color);
				GL_pixel(x+2,y+2,color);
				GL_pixel(x+1,y+3,color);
			break;

			case 'q':
				GL_vertical_line(x+2,y+1,y+4,color);
				GL_pixel(x+1,y+1,color);
				GL_pixel(x,y+2,color);
				GL_pixel(x+1,y+3,color);
			break;

			case 'r':
				GL_vertical_line(x,y+1,y+4,color);
				GL_pixel(x+1,y+2,color);
				GL_pixel(x+2,y+1,color);
			break;

			case 's':
				GL_horizontal_line(y+1,x,x+1,color);
				GL_horizontal_line(y+4,x,x+1,color);
				GL_pixel(x,y+2,color);
				GL_pixel(x+1,y+3,color);
			break;

			case 't':
				GL_vertical_line(x+1,y,y+4,color);
				GL_pixel(x,y+1,color);
				GL_pixel(x+2,y+1,color);
				GL_pixel(x+2,y+4,color);
			break;

			case 'u':
				GL_vertical_line(x,y+1,y+3,color);
				GL_vertical_line(x+2,y+1,y+4,color);
				GL_pixel(x+1,y+4,color);
			break;

			case 'v':
				GL_vertical_line(x,y+1,y+3,color);
				GL_vertical_line(x+2,y+1,y+3,color);
				GL_pixel(x+1,y+4,color);
			break;

			case 'w':
				GL_vertical_line(x,y+1,y+3,color);
				GL_vertical_line(x+2,y+1,y+3,color);
				GL_pixel(x+1,y+4,color);
				GL_vertical_line(x+4,y+1,y+3,color);
				GL_pixel(x+3,y+4,color);
			break;

			case 'x':
				GL_vertical_line(x,y+3,y+4,color);
				GL_vertical_line(x+2,y+3,y+4,color);
				GL_pixel(x,y+1,color);
				GL_pixel(x+2,y+1,color);
				GL_pixel(x+1,y+2,color);
			break;

			case 'y':
				GL_vertical_line(x,y+1,y+2,color);
				GL_vertical_line(x+2,y+1,y+2,color);
				GL_pixel(x+1,y+3,color);
				GL_pixel(x,y+4,color);
			break;

			case 'z':
				GL_horizontal_line(y+1,x,x+3,color);
				GL_horizontal_line(y+4,x,x+3,color);
				GL_pixel(x+2,y+2,color);
				GL_pixel(x+1,y+3,color);
			break;

			case ',':
				GL_horizontal_line(y+2,x,x+1,color);
				GL_pixel(x+1,y+3,color);
				GL_pixel(x,y+4,color);
			break;

			case '.':
				GL_horizontal_line(y+3,x,x+1,color);
				GL_horizontal_line(y+4,x,x+1,color);
			break;

			case '\'':
				GL_horizontal_line(y,x,x+1,color);
				GL_pixel(x+1,y+1,color);
				GL_pixel(x,y+2,color);
			break;

			case ':':
				GL_horizontal_line(y,x,x+1,color);
				GL_horizontal_line(y+1,x,x+1,color);
				GL_horizontal_line(y+3,x,x+1,color);
				GL_horizontal_line(y+4,x,x+1,color);
			break;

			case '!':
				GL_vertical_line(x+1,y,y+2,color);
				GL_pixel(x+1,y+4,color);
			break;

			case '?':
				GL_horizontal_line(y,x,x+1,color);
				GL_pixel(x+2,y+1,color);
				GL_pixel(x+1,y+2,color);
				GL_pixel(x+1,y+4,color);
			break;

			case '0':
				GL_vertical_line(x,y,y+4,color);
				GL_vertical_line(x+2,y,y+4,color);
				GL_pixel(x+1,y,color);
				GL_pixel(x+1,y+4,color);	
			break;

			case '1':
				GL_vertical_line(x+1,y,y+4,color);
			break;

			case '2':
				GL_horizontal_line(y,x,x+1,color);
				GL_horizontal_line(y+4,x+1,x+2,color);
				GL_vertical_line(x+2,y,y+2,color);
				GL_vertical_line(x,y+2,y+4,color);
				GL_pixel(x+1,y+2,color);	
			break;

			case '3':
				GL_horizontal_line(y,x,x+1,color);
				GL_horizontal_line(y+2,x,x+1,color);
				GL_horizontal_line(y+4,x,x+1,color);
				GL_vertical_line(x+2,y,y+4,color);
			break;

			case '4':
				GL_vertical_line(x,y,y+3,color);
				GL_vertical_line(x+2,y,y+4,color);
				GL_pixel(x+1,y+3,color);
			break;

			case '5':
				GL_horizontal_line(y,x+2,x+1,color);
				GL_horizontal_line(y+4,x+1,x,color);
				GL_vertical_line(x,y,y+2,color);
				GL_vertical_line(x+2,y+2,y+4,color);
				GL_pixel(x+1,y+2,color);	
			break;

			case '6':
				GL_horizontal_line(y,x,x+2,color);
				GL_vertical_line(x,y+1,y+4,color);
				GL_vertical_line(x+2,y+1,y+4,color);
				GL_pixel(x+1,y+2,color);	
				GL_pixel(x+1,y+4,color);	
			break;

			case '7':
				GL_horizontal_line(y,x,x+2,color);
				GL_vertical_line(x+2,y+1,y+4,color);
				GL_pixel(x,y+1,color);	
			break;

			case '8':
				GL_vertical_line(x,y,y+4,color);
				GL_vertical_line(x+2,y,y+4,color);
				GL_pixel(x+1,y,color);	
				GL_pixel(x+1,y+2,color);	
				GL_pixel(x+1,y+4,color);	
			break;

			case '9':
				GL_horizontal_line(y+4,x,x+2,color);
				GL_vertical_line(x,y,y+2,color);
				GL_vertical_line(x+2,y,y+4,color);
				GL_pixel(x+1,y,color);	
				GL_pixel(x+1,y+2,color);	
			break;

			case '+':
				GL_vertical_line(x+1,y+1,y+3,color);
				GL_pixel(x,y+2,color);	
				GL_pixel(x+2,y+2,color);
			break;

			case '-':
				GL_horizontal_line(y+2,x,x+2,color);
			break;

			case '*':
				GL_pixel(x,y+1,color);	
				GL_pixel(x+2,y+1,color);
				GL_pixel(x+1,y+2,color);
				GL_pixel(x,y+3,color);
				GL_pixel(x+2,y+3,color);
			break;

			case '/':	
				GL_pixel(x+2,y+1,color);
				GL_pixel(x+1,y+2,color);
				GL_pixel(x,y+3,color);
			break;

			case '%':
				GL_pixel(x,y,color);
				GL_pixel(x+3,y,color);	
				GL_pixel(x+2,y+1,color);
				GL_pixel(x+1,y+2,color);
				GL_pixel(x,y+3,color);
				GL_pixel(x+3,y+3,color);
			break;

			case '\"':
				GL_vertical_line(x,y,y+1,color);
				GL_vertical_line(x+2,y,y+1,color);
			break;
		}

		x=xt;
		l++;
	}
	return xt;
}

/****************************************************************************\
*												*
*	GF_var2str( var, str)								*
*	cette fonction transforme un int en chaine et le met dans str		*
*												*
\****************************************************************************/

GF_var2str(int var, unsigned char *str)
{
	char tmp,zero,cur;
	char i,j;
	int sav;

	sav=var;
	zero=0;
	cur=10;

	for(i=10;i>=0;i--)
	{

		tmp=0;



		while(sav>=pow(10,i))
		{
			sav-=pow(10,i);
			tmp++;
		}

		if(tmp&&!zero) zero=1;

		if(zero)
		{
			switch(tmp)
			{
				case 0:
					str[cur-i]='0';
				break;

				case 1:
					str[cur-i]='1';
				break;

				case 2:
					str[cur-i]='2';
				break;

				case 3:
					str[cur-i]='3';
				break;

				case 4:
					str[cur-i]='4';
				break;

				case 5:
					str[cur-i]='5';
				break;

				case 6:
					str[cur-i]='6';
				break;

				case 7:
					str[cur-i]='7';
				break;

				case 8:
					str[cur-i]='8';
				break;

				case 9:
					str[cur-i]='9';
				break;
			}
		}
		else
		{
			cur--;
		}
	}
}

/************************************************************************************************************\
*																	*
*	pow( var, puissance)													*
*	petite fonction remplassant la fonction dfinie dans math.h (produit moins de bug de type EBR)	*
*																	*
\************************************************************************************************************/

pow(var,power)
{
	int i,r;

	r=var;

	if(power>0)
		for(i=power;i>1;i--)
			r*=var;
	else
		for(i=power;i<=0;i++)
			r/=var;

	return r;
}
